<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: OpenSim::Array&lt; T &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_user.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For MATLAB, Python, Java, and C++ users</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('classOpenSim_1_1Array.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="classOpenSim_1_1Array-members.html">List of all members</a> &#124;
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">OpenSim::Array&lt; T &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>A class for storing an array of values of type T.  
 <a href="classOpenSim_1_1Array.html#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ab1ad1817f69d805fca2d8d2ea0d237ab"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#ab1ad1817f69d805fca2d8d2ea0d237ab">~Array</a> ()</td></tr>
<tr class="memdesc:ab1ad1817f69d805fca2d8d2ea0d237ab"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor.  <a href="classOpenSim_1_1Array.html#ab1ad1817f69d805fca2d8d2ea0d237ab">More...</a><br /></td></tr>
<tr class="separator:ab1ad1817f69d805fca2d8d2ea0d237ab"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa7d3e878a688aadb50918be1f44c9dd3"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#aa7d3e878a688aadb50918be1f44c9dd3">Array</a> (const T &amp;aDefaultValue=T(), int aSize=0, int aCapacity=Array_CAPMIN)</td></tr>
<tr class="memdesc:aa7d3e878a688aadb50918be1f44c9dd3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Default constructor.  <a href="classOpenSim_1_1Array.html#aa7d3e878a688aadb50918be1f44c9dd3">More...</a><br /></td></tr>
<tr class="separator:aa7d3e878a688aadb50918be1f44c9dd3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab03c2b78595c744e5d91cadefd9d82c9"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#ab03c2b78595c744e5d91cadefd9d82c9">Array</a> (const <a class="el" href="classOpenSim_1_1Array.html">Array</a>&lt; T &gt; &amp;aArray)</td></tr>
<tr class="memdesc:ab03c2b78595c744e5d91cadefd9d82c9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Copy constructor.  <a href="classOpenSim_1_1Array.html#ab03c2b78595c744e5d91cadefd9d82c9">More...</a><br /></td></tr>
<tr class="separator:ab03c2b78595c744e5d91cadefd9d82c9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adafac6231aededf0036da946af48e929"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#adafac6231aededf0036da946af48e929">arrayEquals</a> (const <a class="el" href="classOpenSim_1_1Array.html">Array</a>&lt; T &gt; &amp;aArray) const</td></tr>
<tr class="separator:adafac6231aededf0036da946af48e929"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a26cead3f07599c70ffca2188fe5d647e"><td class="memItemLeft" align="right" valign="top">T &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#a26cead3f07599c70ffca2188fe5d647e">operator[]</a> (int aIndex) const</td></tr>
<tr class="memdesc:a26cead3f07599c70ffca2188fe5d647e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the array element at a specified index.  <a href="classOpenSim_1_1Array.html#a26cead3f07599c70ffca2188fe5d647e">More...</a><br /></td></tr>
<tr class="separator:a26cead3f07599c70ffca2188fe5d647e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5267fc885b9a18a12d75d5ac75e519e8"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOpenSim_1_1Array.html">Array</a>&lt; T &gt; &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#a5267fc885b9a18a12d75d5ac75e519e8">operator=</a> (const <a class="el" href="classOpenSim_1_1Array.html">Array</a>&lt; T &gt; &amp;aArray)</td></tr>
<tr class="memdesc:a5267fc885b9a18a12d75d5ac75e519e8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Assign this array to a specified array.  <a href="classOpenSim_1_1Array.html#a5267fc885b9a18a12d75d5ac75e519e8">More...</a><br /></td></tr>
<tr class="separator:a5267fc885b9a18a12d75d5ac75e519e8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a13390077e6788b2a9ceb4e9df30894a4"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#a13390077e6788b2a9ceb4e9df30894a4">operator==</a> (const <a class="el" href="classOpenSim_1_1Array.html">Array</a>&lt; T &gt; &amp;aArray) const</td></tr>
<tr class="memdesc:a13390077e6788b2a9ceb4e9df30894a4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Determine if two arrays are equal.  <a href="classOpenSim_1_1Array.html#a13390077e6788b2a9ceb4e9df30894a4">More...</a><br /></td></tr>
<tr class="separator:a13390077e6788b2a9ceb4e9df30894a4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a614b8c0eb380d6f8aa1288d9706a6b37"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#a614b8c0eb380d6f8aa1288d9706a6b37">computeNewCapacity</a> (int aMinCapacity, int &amp;rNewCapacity)</td></tr>
<tr class="memdesc:a614b8c0eb380d6f8aa1288d9706a6b37"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute a new capacity that is at least as large as a specified minimum capacity; this method does not change the capacity, it simply computes a new recommended capacity.  <a href="classOpenSim_1_1Array.html#a614b8c0eb380d6f8aa1288d9706a6b37">More...</a><br /></td></tr>
<tr class="separator:a614b8c0eb380d6f8aa1288d9706a6b37"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2dfaacf117677d7a6bc024bbbd1e2cbe"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#a2dfaacf117677d7a6bc024bbbd1e2cbe">ensureCapacity</a> (int aCapacity)</td></tr>
<tr class="memdesc:a2dfaacf117677d7a6bc024bbbd1e2cbe"><td class="mdescLeft">&#160;</td><td class="mdescRight">Ensure that the capacity of this array is at least the specified amount.  <a href="classOpenSim_1_1Array.html#a2dfaacf117677d7a6bc024bbbd1e2cbe">More...</a><br /></td></tr>
<tr class="separator:a2dfaacf117677d7a6bc024bbbd1e2cbe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abd3897fd81d9d47dd0e771a61f110b16"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#abd3897fd81d9d47dd0e771a61f110b16">trim</a> ()</td></tr>
<tr class="memdesc:abd3897fd81d9d47dd0e771a61f110b16"><td class="mdescLeft">&#160;</td><td class="mdescRight">Trim the capacity of this array so that it is one larger than the size of this array.  <a href="classOpenSim_1_1Array.html#abd3897fd81d9d47dd0e771a61f110b16">More...</a><br /></td></tr>
<tr class="separator:abd3897fd81d9d47dd0e771a61f110b16"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a59bf4f0ba7bb39c9f87761db280d2dbd"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#a59bf4f0ba7bb39c9f87761db280d2dbd">getCapacity</a> () const</td></tr>
<tr class="memdesc:a59bf4f0ba7bb39c9f87761db280d2dbd"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the capacity of this storage instance.  <a href="classOpenSim_1_1Array.html#a59bf4f0ba7bb39c9f87761db280d2dbd">More...</a><br /></td></tr>
<tr class="separator:a59bf4f0ba7bb39c9f87761db280d2dbd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a14a93e0f3ffac301534392de881e1e72"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#a14a93e0f3ffac301534392de881e1e72">setCapacityIncrement</a> (int aIncrement)</td></tr>
<tr class="memdesc:a14a93e0f3ffac301534392de881e1e72"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the amount by which the capacity is increased when the capacity of of the array in exceeded.  <a href="classOpenSim_1_1Array.html#a14a93e0f3ffac301534392de881e1e72">More...</a><br /></td></tr>
<tr class="separator:a14a93e0f3ffac301534392de881e1e72"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3aef106f2e98ff302f0589999ec814a8"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#a3aef106f2e98ff302f0589999ec814a8">getCapacityIncrement</a> () const</td></tr>
<tr class="memdesc:a3aef106f2e98ff302f0589999ec814a8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the amount by which the capacity is increased.  <a href="classOpenSim_1_1Array.html#a3aef106f2e98ff302f0589999ec814a8">More...</a><br /></td></tr>
<tr class="separator:a3aef106f2e98ff302f0589999ec814a8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a78b56564ddc02e3b47dbb75a9349ea76"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#a78b56564ddc02e3b47dbb75a9349ea76">setSize</a> (int aSize)</td></tr>
<tr class="memdesc:a78b56564ddc02e3b47dbb75a9349ea76"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the size of the array.  <a href="classOpenSim_1_1Array.html#a78b56564ddc02e3b47dbb75a9349ea76">More...</a><br /></td></tr>
<tr class="separator:a78b56564ddc02e3b47dbb75a9349ea76"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0bc97e78e0a95f80b03c9cdbc27dc10b"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#a0bc97e78e0a95f80b03c9cdbc27dc10b">getSize</a> () const</td></tr>
<tr class="memdesc:a0bc97e78e0a95f80b03c9cdbc27dc10b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the size of the array.  <a href="classOpenSim_1_1Array.html#a0bc97e78e0a95f80b03c9cdbc27dc10b">More...</a><br /></td></tr>
<tr class="separator:a0bc97e78e0a95f80b03c9cdbc27dc10b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aace1abea44dee8d5aaa8c298a72f0c58"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#aace1abea44dee8d5aaa8c298a72f0c58">size</a> () const</td></tr>
<tr class="memdesc:aace1abea44dee8d5aaa8c298a72f0c58"><td class="mdescLeft">&#160;</td><td class="mdescRight">Alternate name for <a class="el" href="classOpenSim_1_1Array.html#a0bc97e78e0a95f80b03c9cdbc27dc10b" title="Get the size of the array.">getSize()</a>.  <a href="classOpenSim_1_1Array.html#aace1abea44dee8d5aaa8c298a72f0c58">More...</a><br /></td></tr>
<tr class="separator:aace1abea44dee8d5aaa8c298a72f0c58"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a16969ea83d0bb1b3cc9ceade180012fa"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#a16969ea83d0bb1b3cc9ceade180012fa">append</a> (const T &amp;aValue)</td></tr>
<tr class="memdesc:a16969ea83d0bb1b3cc9ceade180012fa"><td class="mdescLeft">&#160;</td><td class="mdescRight">Append a value onto the array.  <a href="classOpenSim_1_1Array.html#a16969ea83d0bb1b3cc9ceade180012fa">More...</a><br /></td></tr>
<tr class="separator:a16969ea83d0bb1b3cc9ceade180012fa"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afd5af71649fbf9df881e48f04aeee371"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#afd5af71649fbf9df881e48f04aeee371">append</a> (const <a class="el" href="classOpenSim_1_1Array.html">Array</a>&lt; T &gt; &amp;aArray)</td></tr>
<tr class="memdesc:afd5af71649fbf9df881e48f04aeee371"><td class="mdescLeft">&#160;</td><td class="mdescRight">Append an array of values.  <a href="classOpenSim_1_1Array.html#afd5af71649fbf9df881e48f04aeee371">More...</a><br /></td></tr>
<tr class="separator:afd5af71649fbf9df881e48f04aeee371"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a27e127f6bb6960bf4798d40a1d87bc83"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#a27e127f6bb6960bf4798d40a1d87bc83">append</a> (int aSize, const T *aArray)</td></tr>
<tr class="memdesc:a27e127f6bb6960bf4798d40a1d87bc83"><td class="mdescLeft">&#160;</td><td class="mdescRight">Append an array of values.  <a href="classOpenSim_1_1Array.html#a27e127f6bb6960bf4798d40a1d87bc83">More...</a><br /></td></tr>
<tr class="separator:a27e127f6bb6960bf4798d40a1d87bc83"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a919a732bf18326959e6aafa4f6ade5fc"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#a919a732bf18326959e6aafa4f6ade5fc">insert</a> (int aIndex, const T &amp;aValue)</td></tr>
<tr class="memdesc:a919a732bf18326959e6aafa4f6ade5fc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Insert a value into the array at a specified index.  <a href="classOpenSim_1_1Array.html#a919a732bf18326959e6aafa4f6ade5fc">More...</a><br /></td></tr>
<tr class="separator:a919a732bf18326959e6aafa4f6ade5fc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae800e1737112b46456c730f5115046b7"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#ae800e1737112b46456c730f5115046b7">remove</a> (int aIndex)</td></tr>
<tr class="memdesc:ae800e1737112b46456c730f5115046b7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Remove a value from the array at a specified index.  <a href="classOpenSim_1_1Array.html#ae800e1737112b46456c730f5115046b7">More...</a><br /></td></tr>
<tr class="separator:ae800e1737112b46456c730f5115046b7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a73d7e2c126c8379b1d9cf62b7df86b83"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#a73d7e2c126c8379b1d9cf62b7df86b83">set</a> (int aIndex, const T &amp;aValue)</td></tr>
<tr class="memdesc:a73d7e2c126c8379b1d9cf62b7df86b83"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the value at a specified index.  <a href="classOpenSim_1_1Array.html#a73d7e2c126c8379b1d9cf62b7df86b83">More...</a><br /></td></tr>
<tr class="separator:a73d7e2c126c8379b1d9cf62b7df86b83"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa9c5f16e2584468b98bbf682993994da"><td class="memItemLeft" align="right" valign="top">T *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#aa9c5f16e2584468b98bbf682993994da">get</a> ()</td></tr>
<tr class="memdesc:aa9c5f16e2584468b98bbf682993994da"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a pointer to the low-level array.  <a href="classOpenSim_1_1Array.html#aa9c5f16e2584468b98bbf682993994da">More...</a><br /></td></tr>
<tr class="separator:aa9c5f16e2584468b98bbf682993994da"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1451d6b2fcb6e8a0042d93bb47213eb7"><td class="memItemLeft" align="right" valign="top">const T *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#a1451d6b2fcb6e8a0042d93bb47213eb7">get</a> () const</td></tr>
<tr class="memdesc:a1451d6b2fcb6e8a0042d93bb47213eb7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a pointer to the low-level array.  <a href="classOpenSim_1_1Array.html#a1451d6b2fcb6e8a0042d93bb47213eb7">More...</a><br /></td></tr>
<tr class="separator:a1451d6b2fcb6e8a0042d93bb47213eb7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa172804c369b8327874f0dd610cf88c5"><td class="memItemLeft" align="right" valign="top">const T &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#aa172804c369b8327874f0dd610cf88c5">get</a> (int aIndex) const</td></tr>
<tr class="memdesc:aa172804c369b8327874f0dd610cf88c5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a const reference to the value at a specified array index.  <a href="classOpenSim_1_1Array.html#aa172804c369b8327874f0dd610cf88c5">More...</a><br /></td></tr>
<tr class="separator:aa172804c369b8327874f0dd610cf88c5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a04f2fb56c5e091b0f28a467c11225554"><td class="memItemLeft" align="right" valign="top">T &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#a04f2fb56c5e091b0f28a467c11225554">updElt</a> (int aIndex) const</td></tr>
<tr class="memdesc:a04f2fb56c5e091b0f28a467c11225554"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a writable reference to value at a specified array index.  <a href="classOpenSim_1_1Array.html#a04f2fb56c5e091b0f28a467c11225554">More...</a><br /></td></tr>
<tr class="separator:a04f2fb56c5e091b0f28a467c11225554"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a11cf45656a28214cf5ca393bc3b8705f"><td class="memItemLeft" align="right" valign="top">const T &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#a11cf45656a28214cf5ca393bc3b8705f">getLast</a> () const</td></tr>
<tr class="memdesc:a11cf45656a28214cf5ca393bc3b8705f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the last value in the array.  <a href="classOpenSim_1_1Array.html#a11cf45656a28214cf5ca393bc3b8705f">More...</a><br /></td></tr>
<tr class="separator:a11cf45656a28214cf5ca393bc3b8705f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af603fdb2420c1cfdddacd2fe1ab98306"><td class="memItemLeft" align="right" valign="top">T &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#af603fdb2420c1cfdddacd2fe1ab98306">updLast</a> () const</td></tr>
<tr class="memdesc:af603fdb2420c1cfdddacd2fe1ab98306"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get writable reference to last value in the array.  <a href="classOpenSim_1_1Array.html#af603fdb2420c1cfdddacd2fe1ab98306">More...</a><br /></td></tr>
<tr class="separator:af603fdb2420c1cfdddacd2fe1ab98306"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a62a8c65a21fe11ab8bf42e533dcb4048"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#a62a8c65a21fe11ab8bf42e533dcb4048">findIndex</a> (const T &amp;aValue) const</td></tr>
<tr class="memdesc:a62a8c65a21fe11ab8bf42e533dcb4048"><td class="mdescLeft">&#160;</td><td class="mdescRight">Linear search for an element matching a given value.  <a href="classOpenSim_1_1Array.html#a62a8c65a21fe11ab8bf42e533dcb4048">More...</a><br /></td></tr>
<tr class="separator:a62a8c65a21fe11ab8bf42e533dcb4048"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5e89a83520345989520bce142262b9ab"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#a5e89a83520345989520bce142262b9ab">rfindIndex</a> (const T &amp;aValue) const</td></tr>
<tr class="memdesc:a5e89a83520345989520bce142262b9ab"><td class="mdescLeft">&#160;</td><td class="mdescRight">Linear search in reverse for an element matching a given value.  <a href="classOpenSim_1_1Array.html#a5e89a83520345989520bce142262b9ab">More...</a><br /></td></tr>
<tr class="separator:a5e89a83520345989520bce142262b9ab"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0befc296631d523a2bfef19eef8a1fc2"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Array.html#a0befc296631d523a2bfef19eef8a1fc2">searchBinary</a> (const T &amp;aValue, bool aFindFirst=false, int aLo=-1, int aHi=-1) const</td></tr>
<tr class="memdesc:a0befc296631d523a2bfef19eef8a1fc2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Search for the largest value in the array that is less than or equal to a specified value.  <a href="classOpenSim_1_1Array.html#a0befc296631d523a2bfef19eef8a1fc2">More...</a><br /></td></tr>
<tr class="separator:a0befc296631d523a2bfef19eef8a1fc2"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description </h2>
<div class="textblock"><h3>template&lt;class T&gt;<br />
class OpenSim::Array&lt; T &gt;</h3>

<p>A class for storing an array of values of type T. </p>
<p>The capacity of the class grows as needed. To use this template for a class of type T, class T should implement the following methods: default constructor, copy constructor, assignment operator (=), equality operator (==), and less than operator (&lt;).</p>
<dl class="section version"><dt>Version</dt><dd>1.0 </dd></dl>
<dl class="section author"><dt>Author</dt><dd>Frank C. Anderson </dd></dl>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="ab1ad1817f69d805fca2d8d2ea0d237ab"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab1ad1817f69d805fca2d8d2ea0d237ab">&#9670;&nbsp;</a></span>~Array()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::~<a class="el" href="classOpenSim_1_1Array.html">Array</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Destructor. </p>
<p>When the array is deleted, references to elements of this array become invalid. </p>

</div>
</div>
<a id="aa7d3e878a688aadb50918be1f44c9dd3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa7d3e878a688aadb50918be1f44c9dd3">&#9670;&nbsp;</a></span>Array() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::<a class="el" href="classOpenSim_1_1Array.html">Array</a> </td>
          <td>(</td>
          <td class="paramtype">const T &amp;&#160;</td>
          <td class="paramname"><em>aDefaultValue</em> = <code>T()</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>aSize</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>aCapacity</em> = <code>Array_CAPMIN</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">explicit</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Default constructor. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">aDefaultValue</td><td>Default value of an array element. This value is used to initialize array elements as the size of the array is changed. </td></tr>
    <tr><td class="paramname">aSize</td><td>Initial size of the array. The array elements are initialized to aDefaultValue. </td></tr>
    <tr><td class="paramname">aCapacity</td><td>Initial capacity of the array. The initial capacity is guaranteed to be at least as large as aSize + 1. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ab03c2b78595c744e5d91cadefd9d82c9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab03c2b78595c744e5d91cadefd9d82c9">&#9670;&nbsp;</a></span>Array() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::<a class="el" href="classOpenSim_1_1Array.html">Array</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1Array.html">Array</a>&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>aArray</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Copy constructor. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">aArray</td><td><a class="el" href="classOpenSim_1_1Array.html" title="A class for storing an array of values of type T.">Array</a> to be copied. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="afd5af71649fbf9df881e48f04aeee371"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afd5af71649fbf9df881e48f04aeee371">&#9670;&nbsp;</a></span>append() <span class="overload">[1/3]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::append </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1Array.html">Array</a>&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>aArray</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Append an array of values. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">aArray</td><td><a class="el" href="classOpenSim_1_1Array.html" title="A class for storing an array of values of type T.">Array</a> of values to append. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>New size of the array, or, equivalently, the index to the new first empty element of the array. </dd></dl>

</div>
</div>
<a id="a16969ea83d0bb1b3cc9ceade180012fa"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a16969ea83d0bb1b3cc9ceade180012fa">&#9670;&nbsp;</a></span>append() <span class="overload">[2/3]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::append </td>
          <td>(</td>
          <td class="paramtype">const T &amp;&#160;</td>
          <td class="paramname"><em>aValue</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Append a value onto the array. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">aValue</td><td>Value to be appended. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>New size of the array, or, equivalently, the index to the new first empty element of the array. </dd></dl>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1Array.html#afd5af71649fbf9df881e48f04aeee371">OpenSim::Array&lt; OpenSim::Array&lt; double &gt; * &gt;::append()</a>, <a class="el" href="classOpenSim_1_1MocoBounds.html#a9b5e10019ebc8bb4893254d56d244f85">OpenSim::MocoBounds::getAsArray()</a>, <a class="el" href="classOpenSim_1_1Set.html#a2e2c585cfa4f94de58715ffcb6fb0c08">OpenSim::Set&lt; Control &gt;::getGroupNames()</a>, <a class="el" href="classOpenSim_1_1Set.html#afc53e47a6ff3e06cd99dfa045bfe58bf">OpenSim::Set&lt; Control &gt;::getGroupNamesContaining()</a>, and <a class="el" href="classOpenSim_1_1Set.html#a80780cd35b054695b0d26c465241c6fd">OpenSim::Set&lt; Control &gt;::getNames()</a>.</p>

</div>
</div>
<a id="a27e127f6bb6960bf4798d40a1d87bc83"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a27e127f6bb6960bf4798d40a1d87bc83">&#9670;&nbsp;</a></span>append() <span class="overload">[3/3]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::append </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>aSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const T *&#160;</td>
          <td class="paramname"><em>aArray</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Append an array of values. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">aSize</td><td>Size of the array to append. </td></tr>
    <tr><td class="paramname">aArray</td><td><a class="el" href="classOpenSim_1_1Array.html" title="A class for storing an array of values of type T.">Array</a> of values to append. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>New size of the array, or, equivalently, the index to the new first empty element of the array. </dd></dl>

</div>
</div>
<a id="adafac6231aededf0036da946af48e929"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adafac6231aededf0036da946af48e929">&#9670;&nbsp;</a></span>arrayEquals()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::arrayEquals </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1Array.html">Array</a>&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>aArray</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a614b8c0eb380d6f8aa1288d9706a6b37"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a614b8c0eb380d6f8aa1288d9706a6b37">&#9670;&nbsp;</a></span>computeNewCapacity()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::computeNewCapacity </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>aMinCapacity</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int &amp;&#160;</td>
          <td class="paramname"><em>rNewCapacity</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Compute a new capacity that is at least as large as a specified minimum capacity; this method does not change the capacity, it simply computes a new recommended capacity. </p>
<p>If the capacity increment is negative, the current capacity is doubled until the computed capacity is greater than or equal to the specified minimum capacity. If the capacity increment is positive, the current capacity increment by this amount until the computed capacity is greater than or equal to the specified minimum capacity. If the capacity increment is zero, the computed capacity is set to the current capacity and false is returned.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">rNewCapacity</td><td>New computed capacity. </td></tr>
    <tr><td class="paramname">aMinCapacity</td><td>Minimum new computed capacity. The computed capacity is incremented until it is at least as large as aMinCapacity, assuming the capacity increment is not zero. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>True if the new capacity was increased, false otherwise (i.e., if the capacity increment is set to 0). </dd></dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="classOpenSim_1_1Array.html#a14a93e0f3ffac301534392de881e1e72" title="Set the amount by which the capacity is increased when the capacity of of the array in exceeded.">setCapacityIncrement()</a> </dd></dl>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1Array.html#a16969ea83d0bb1b3cc9ceade180012fa">OpenSim::Array&lt; OpenSim::Array&lt; double &gt; * &gt;::append()</a>, <a class="el" href="classOpenSim_1_1Array.html#aa7d3e878a688aadb50918be1f44c9dd3">OpenSim::Array&lt; OpenSim::Array&lt; double &gt; * &gt;::Array()</a>, <a class="el" href="classOpenSim_1_1Array.html#a919a732bf18326959e6aafa4f6ade5fc">OpenSim::Array&lt; OpenSim::Array&lt; double &gt; * &gt;::insert()</a>, <a class="el" href="classOpenSim_1_1Array.html#a73d7e2c126c8379b1d9cf62b7df86b83">OpenSim::Array&lt; OpenSim::Array&lt; double &gt; * &gt;::set()</a>, and <a class="el" href="classOpenSim_1_1Array.html#a78b56564ddc02e3b47dbb75a9349ea76">OpenSim::Array&lt; OpenSim::Array&lt; double &gt; * &gt;::setSize()</a>.</p>

</div>
</div>
<a id="a2dfaacf117677d7a6bc024bbbd1e2cbe"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2dfaacf117677d7a6bc024bbbd1e2cbe">&#9670;&nbsp;</a></span>ensureCapacity()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::ensureCapacity </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>aCapacity</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Ensure that the capacity of this array is at least the specified amount. </p>
<p>Note that the newly allocated array elements are not initialized.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">aCapacity</td><td>Desired capacity. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if the capacity was successfully obtained, false otherwise. </dd></dl>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1Array.html#a16969ea83d0bb1b3cc9ceade180012fa">OpenSim::Array&lt; OpenSim::Array&lt; double &gt; * &gt;::append()</a>, <a class="el" href="classOpenSim_1_1Array.html#aa7d3e878a688aadb50918be1f44c9dd3">OpenSim::Array&lt; OpenSim::Array&lt; double &gt; * &gt;::Array()</a>, <a class="el" href="classOpenSim_1_1Array.html#a919a732bf18326959e6aafa4f6ade5fc">OpenSim::Array&lt; OpenSim::Array&lt; double &gt; * &gt;::insert()</a>, <a class="el" href="classOpenSim_1_1Array.html#a73d7e2c126c8379b1d9cf62b7df86b83">OpenSim::Array&lt; OpenSim::Array&lt; double &gt; * &gt;::set()</a>, and <a class="el" href="classOpenSim_1_1Array.html#a78b56564ddc02e3b47dbb75a9349ea76">OpenSim::Array&lt; OpenSim::Array&lt; double &gt; * &gt;::setSize()</a>.</p>

</div>
</div>
<a id="a62a8c65a21fe11ab8bf42e533dcb4048"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a62a8c65a21fe11ab8bf42e533dcb4048">&#9670;&nbsp;</a></span>findIndex()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::findIndex </td>
          <td>(</td>
          <td class="paramtype">const T &amp;&#160;</td>
          <td class="paramname"><em>aValue</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Linear search for an element matching a given value. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">aValue</td><td>Value to which the array elements are compared. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Index of the array element matching aValue. If there is more than one such elements with the same value the index of the first of these elements is returned. If no match is found, -1 is returned. </dd></dl>

</div>
</div>
<a id="aa9c5f16e2584468b98bbf682993994da"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa9c5f16e2584468b98bbf682993994da">&#9670;&nbsp;</a></span>get() <span class="overload">[1/3]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">T* <a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::get </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get a pointer to the low-level array. </p>
<dl class="section return"><dt>Returns</dt><dd>Pointer to the low-level array. </dd></dl>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1MarkerPair.html#a17a151f16b6e6612ee5813abf1b5d9a0">OpenSim::MarkerPair::getMarkerName()</a>.</p>

</div>
</div>
<a id="a1451d6b2fcb6e8a0042d93bb47213eb7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1451d6b2fcb6e8a0042d93bb47213eb7">&#9670;&nbsp;</a></span>get() <span class="overload">[2/3]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const T* <a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::get </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get a pointer to the low-level array. </p>
<dl class="section return"><dt>Returns</dt><dd>Pointer to the low-level array. </dd></dl>

</div>
</div>
<a id="aa172804c369b8327874f0dd610cf88c5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa172804c369b8327874f0dd610cf88c5">&#9670;&nbsp;</a></span>get() <span class="overload">[3/3]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const T&amp; <a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::get </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>aIndex</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get a const reference to the value at a specified array index. </p>
<p>If the index is negative or passed the end of the array, an exception is thrown.</p>
<p>For faster execution, the array elements can be accessed through the overloaded operator[], which does no bounds checking.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">aIndex</td><td>Index of the desired array element. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>const reference to the array element. </dd></dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname"><a class="el" href="classOpenSim_1_1Exception.html" title="A class for basic exception functionality.">Exception</a></td><td>if (aIndex&lt;0)||(aIndex&gt;=_size). </td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd>operator[]. </dd></dl>

</div>
</div>
<a id="a59bf4f0ba7bb39c9f87761db280d2dbd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a59bf4f0ba7bb39c9f87761db280d2dbd">&#9670;&nbsp;</a></span>getCapacity()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::getCapacity </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the capacity of this storage instance. </p>

</div>
</div>
<a id="a3aef106f2e98ff302f0589999ec814a8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3aef106f2e98ff302f0589999ec814a8">&#9670;&nbsp;</a></span>getCapacityIncrement()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::getCapacityIncrement </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the amount by which the capacity is increased. </p>

</div>
</div>
<a id="a11cf45656a28214cf5ca393bc3b8705f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a11cf45656a28214cf5ca393bc3b8705f">&#9670;&nbsp;</a></span>getLast()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const T&amp; <a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::getLast </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the last value in the array. </p>
<dl class="section return"><dt>Returns</dt><dd>Last value in the array. </dd></dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname"><a class="el" href="classOpenSim_1_1Exception.html" title="A class for basic exception functionality.">Exception</a></td><td>if the array is empty. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a0bc97e78e0a95f80b03c9cdbc27dc10b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0bc97e78e0a95f80b03c9cdbc27dc10b">&#9670;&nbsp;</a></span>getSize()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::getSize </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the size of the array. </p>
<dl class="section return"><dt>Returns</dt><dd>Size of the array. </dd></dl>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1Array.html#afd5af71649fbf9df881e48f04aeee371">OpenSim::Array&lt; OpenSim::Array&lt; double &gt; * &gt;::append()</a>, <a class="el" href="classOpenSim_1_1PropertyBoolArray.html#a76485af3ee584ae95a14378a92d3bf34">OpenSim::PropertyBoolArray::getArraySize()</a>, <a class="el" href="classOpenSim_1_1PropertyDblArray.html#a83aee1a293584183b0a82e0910f08102">OpenSim::PropertyDblArray::getArraySize()</a>, <a class="el" href="classOpenSim_1_1PropertyIntArray.html#a791a2c019ff1748efd33cccdd9e002e0">OpenSim::PropertyIntArray::getArraySize()</a>, <a class="el" href="classOpenSim_1_1PropertyStrArray.html#a01c50edfc5584bebc048465be2edace0">OpenSim::PropertyStrArray::getArraySize()</a>, <a class="el" href="classOpenSim_1_1MarkerPair.html#a17a151f16b6e6612ee5813abf1b5d9a0">OpenSim::MarkerPair::getMarkerName()</a>, <a class="el" href="classOpenSim_1_1GCVSpline.html#a96d2fed0708691a4f8fa1f283ea1b8e7">OpenSim::GCVSpline::getNumberOfPoints()</a>, <a class="el" href="classOpenSim_1_1PiecewiseConstantFunction.html#ab6e853cdd3ba35012b1483807e235376">OpenSim::PiecewiseConstantFunction::getNumberOfPoints()</a>, <a class="el" href="classOpenSim_1_1PiecewiseLinearFunction.html#ab437631a102960eda568ccacd2e94332">OpenSim::PiecewiseLinearFunction::getNumberOfPoints()</a>, <a class="el" href="classOpenSim_1_1SimmSpline.html#a3c3a1b602d98dafa828a00e79f1ffd4f">OpenSim::SimmSpline::getNumberOfPoints()</a>, <a class="el" href="classOpenSim_1_1Storage.html#a42fabcf4d0a2f92b0ea3d02fd1bf6d10">OpenSim::Storage::getSize()</a>, <a class="el" href="classOpenSim_1_1XMLDocument.html#a101fa4f24de600d99b7a10ef228bb549">OpenSim::XMLDocument::hasDefaultObjects()</a>, <a class="el" href="classOpenSim_1_1PropertyDblVec__.html#a15dc3a048aac7a51a974f291cbeab542">OpenSim::PropertyDblVec_&lt; 3 &gt;::setValue()</a>, and <a class="el" href="classOpenSim_1_1Array.html#aace1abea44dee8d5aaa8c298a72f0c58">OpenSim::Array&lt; OpenSim::Array&lt; double &gt; * &gt;::size()</a>.</p>

</div>
</div>
<a id="a919a732bf18326959e6aafa4f6ade5fc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a919a732bf18326959e6aafa4f6ade5fc">&#9670;&nbsp;</a></span>insert()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::insert </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>aIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const T &amp;&#160;</td>
          <td class="paramname"><em>aValue</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Insert a value into the array at a specified index. </p>
<p>This method is relatively computationally costly since many of the array elements may need to be shifted.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">aValue</td><td>Value to be inserted. </td></tr>
    <tr><td class="paramname">aIndex</td><td>Index at which to insert the new value. All current elements from aIndex to the end of the array are shifted one place in the direction of the end of the array. If the specified index is greater than the current size of the array, the size of the array is increased to aIndex+1 and the intervening new elements are initialized to the default value that was specified at the time of construction. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Size of the array after the insertion. </dd></dl>

</div>
</div>
<a id="a5267fc885b9a18a12d75d5ac75e519e8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5267fc885b9a18a12d75d5ac75e519e8">&#9670;&nbsp;</a></span>operator=()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1Array.html">Array</a>&lt;T&gt;&amp; <a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::operator= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1Array.html">Array</a>&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>aArray</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Assign this array to a specified array. </p>
<p>This operator makes a complete copy of the specified array; all member variables are copied. So, the result is two identical, independent arrays.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">aArray</td><td><a class="el" href="classOpenSim_1_1Array.html" title="A class for storing an array of values of type T.">Array</a> to be copied. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Reference to this array. </dd></dl>

</div>
</div>
<a id="a13390077e6788b2a9ceb4e9df30894a4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a13390077e6788b2a9ceb4e9df30894a4">&#9670;&nbsp;</a></span>operator==()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::operator== </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1Array.html">Array</a>&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>aArray</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Determine if two arrays are equal. </p>
<p>Two arrays are equal if their contents are equal. That is, each array must be the same length and their corresponding array elements must be equal.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">aArray</td><td><a class="el" href="classOpenSim_1_1Array.html" title="A class for storing an array of values of type T.">Array</a> to be tested as equal. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>True if equal, false if not equal. </dd></dl>

</div>
</div>
<a id="a26cead3f07599c70ffca2188fe5d647e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a26cead3f07599c70ffca2188fe5d647e">&#9670;&nbsp;</a></span>operator[]()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">T&amp; <a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::operator[] </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>aIndex</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the array element at a specified index. </p>
<p>This overloaded operator can be used both to set and get element values: </p><div class="fragment"><div class="line">Array&lt;T&gt; array(2);</div>
<div class="line">T value = array[i];</div>
<div class="line">array[i] = value;</div>
</div><!-- fragment --><p>This operator is intended for accessing array elements with as little overhead as possible, so no error checking is performed. The caller must make sure the specified index is within the bounds of the array. If error checking is desired, use <a class="el" href="classOpenSim_1_1Array.html#aa9c5f16e2584468b98bbf682993994da" title="Get a pointer to the low-level array.">Array::get()</a>.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">aIndex</td><td>Index of the desired element (0 &lt;= aIndex &lt; _size). </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Reference to the array element. </dd></dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="classOpenSim_1_1Array.html#aa9c5f16e2584468b98bbf682993994da" title="Get a pointer to the low-level array.">get()</a>. </dd></dl>

</div>
</div>
<a id="ae800e1737112b46456c730f5115046b7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae800e1737112b46456c730f5115046b7">&#9670;&nbsp;</a></span>remove()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::remove </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>aIndex</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Remove a value from the array at a specified index. </p>
<p>This method is relatively computationally costly since many of the array elements may need to be shifted.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">aIndex</td><td>Index of the value to remove. All elements from aIndex to the end of the array are shifted one place toward the beginning of the array. If aIndex is less than 0 or greater than or equal to the current size of the array, no element is removed. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Size of the array after the removal. </dd></dl>

</div>
</div>
<a id="a5e89a83520345989520bce142262b9ab"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5e89a83520345989520bce142262b9ab">&#9670;&nbsp;</a></span>rfindIndex()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::rfindIndex </td>
          <td>(</td>
          <td class="paramtype">const T &amp;&#160;</td>
          <td class="paramname"><em>aValue</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Linear search in reverse for an element matching a given value. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">aValue</td><td>Value to which the array elements are compared. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Index of the array element matching aValue. If there is more than one such elements with the same value the index of the last of these elements is returned. If no match is found, -1 is returned. </dd></dl>

</div>
</div>
<a id="a0befc296631d523a2bfef19eef8a1fc2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0befc296631d523a2bfef19eef8a1fc2">&#9670;&nbsp;</a></span>searchBinary()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::searchBinary </td>
          <td>(</td>
          <td class="paramtype">const T &amp;&#160;</td>
          <td class="paramname"><em>aValue</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>aFindFirst</em> = <code>false</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>aLo</em> = <code>-1</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>aHi</em> = <code>-1</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Search for the largest value in the array that is less than or equal to a specified value. </p>
<p>If there is more than one element with this largest value, the index of the first of these elements can optionally be found, but this can be up to twice as costly.</p>
<p>This method assumes that the array element values monotonically increase as the array index increases. Note that monotonically increase means never decrease, so it is permissible for elements to</p>
<p>A binary search is performed (i.e., the array is repeatedly subdivided into two bins one of which must contain the specified until the appropriate element is identified), so the performance of this method is approximately ln(n), where n is the size of the array.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">aValue</td><td>Value to which the array elements are compared. </td></tr>
    <tr><td class="paramname">aFindFirst</td><td>If true, find the first element that satisfies the search. If false, the index of any element that satisfies the search can be returned- which index will be returned depends on the length of the array and is therefore somewhat arbitrary. By default, this flag is false. </td></tr>
    <tr><td class="paramname">aLo</td><td>Lowest array index to consider in the search. </td></tr>
    <tr><td class="paramname">aHi</td><td>Highest array index to consider in the search. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Index of the array element that has the largest value that is less than or equal to aValue. If there is more than one such elements with the same value and aFindFirst is set to true, the index of the first of these elements is returned. If an error is encountered (e.g., the array is empty), or the array contains no element that is less than or equal to aValue, -1 is returned. </dd></dl>

</div>
</div>
<a id="a73d7e2c126c8379b1d9cf62b7df86b83"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a73d7e2c126c8379b1d9cf62b7df86b83">&#9670;&nbsp;</a></span>set()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::set </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>aIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const T &amp;&#160;</td>
          <td class="paramname"><em>aValue</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Set the value at a specified index. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">aIndex</td><td>Index of the array element to be set. It is permissible for aIndex to be past the current end of the array- the capacity will be increased if necessary. Values between the current end of the array and aIndex are not initialized. </td></tr>
    <tr><td class="paramname">aValue</td><td>Value. </td></tr>
  </table>
  </dd>
</dl>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1MarkerPair.html#ae4055c1477a77fc87543c6120b40da4e">OpenSim::MarkerPair::setMarkerName()</a>.</p>

</div>
</div>
<a id="a14a93e0f3ffac301534392de881e1e72"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a14a93e0f3ffac301534392de881e1e72">&#9670;&nbsp;</a></span>setCapacityIncrement()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::setCapacityIncrement </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>aIncrement</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Set the amount by which the capacity is increased when the capacity of of the array in exceeded. </p>
<p>If the specified increment is negative, the capacity is set to double whenever the capacity is exceeded.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">aIncrement</td><td>Desired capacity increment. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a78b56564ddc02e3b47dbb75a9349ea76"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a78b56564ddc02e3b47dbb75a9349ea76">&#9670;&nbsp;</a></span>setSize()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::setSize </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>aSize</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Set the size of the array. </p>
<p>This method can be used to either increase or decrease the size of the array. If this size of the array is increased, the new elements are initialized to the default value that was specified at the time of construction.</p>
<p>Note that the size of an array is different than its capacity. The size indicates how many valid elements are stored in an array. The capacity indicates how much the size of the array can be increased without allocated more memory. At all times size &lt;= capacity.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">aSize</td><td>Desired size of the array. The size must be greater than or equal to zero. </td></tr>
  </table>
  </dd>
</dl>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1PropertyBoolArray.html#aebaea4a3c1c191b721e39316963eb86d">OpenSim::PropertyBoolArray::clearValues()</a>, <a class="el" href="classOpenSim_1_1PropertyDblArray.html#a0fa3453b958174eaee7f9b57ec523567">OpenSim::PropertyDblArray::clearValues()</a>, <a class="el" href="classOpenSim_1_1PropertyIntArray.html#a3554b3a99d451442dca91f857b7a4ad8">OpenSim::PropertyIntArray::clearValues()</a>, <a class="el" href="classOpenSim_1_1PropertyStrArray.html#a034d73bb6380a01a2fd6e1cd7724db1c">OpenSim::PropertyStrArray::clearValues()</a>, <a class="el" href="classOpenSim_1_1Set.html#a2e2c585cfa4f94de58715ffcb6fb0c08">OpenSim::Set&lt; Control &gt;::getGroupNames()</a>, <a class="el" href="classOpenSim_1_1Set.html#afc53e47a6ff3e06cd99dfa045bfe58bf">OpenSim::Set&lt; Control &gt;::getGroupNamesContaining()</a>, <a class="el" href="classOpenSim_1_1Array.html#a919a732bf18326959e6aafa4f6ade5fc">OpenSim::Array&lt; OpenSim::Array&lt; double &gt; * &gt;::insert()</a>, <a class="el" href="classOpenSim_1_1PropertyDblVec__.html#aafeec5ab64d7aed0dd119e52578452cd">OpenSim::PropertyDblVec_&lt; 3 &gt;::PropertyDblVec_()</a>, and <a class="el" href="classOpenSim_1_1Storage.html#afa7717a4c221f4b038ead6d3b7e55b94">OpenSim::Storage::purge()</a>.</p>

</div>
</div>
<a id="aace1abea44dee8d5aaa8c298a72f0c58"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aace1abea44dee8d5aaa8c298a72f0c58">&#9670;&nbsp;</a></span>size()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::size </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Alternate name for <a class="el" href="classOpenSim_1_1Array.html#a0bc97e78e0a95f80b03c9cdbc27dc10b" title="Get the size of the array.">getSize()</a>. </p>

</div>
</div>
<a id="abd3897fd81d9d47dd0e771a61f110b16"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abd3897fd81d9d47dd0e771a61f110b16">&#9670;&nbsp;</a></span>trim()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::trim </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Trim the capacity of this array so that it is one larger than the size of this array. </p>
<p>This is useful for reducing the amount of memory used by this array. This capacity is kept at one larger than the size so that, for example, an array of characters can be treated as a NULL terminated string. </p>

</div>
</div>
<a id="a04f2fb56c5e091b0f28a467c11225554"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a04f2fb56c5e091b0f28a467c11225554">&#9670;&nbsp;</a></span>updElt()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">T&amp; <a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::updElt </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>aIndex</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get a writable reference to value at a specified array index. </p>
<p>If the index is negative or passed the end of the array, an exception is thrown.</p>
<p>For faster execution, the array elements can be accessed through the overloaded operator[], which does no bounds checking.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">aIndex</td><td>Index of the desired array element. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Writable reference to the array element. </dd></dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname"><a class="el" href="classOpenSim_1_1Exception.html" title="A class for basic exception functionality.">Exception</a></td><td>if (aIndex&lt;0)||(aIndex&gt;=_size). </td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd>operator[]. </dd></dl>

</div>
</div>
<a id="af603fdb2420c1cfdddacd2fe1ab98306"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af603fdb2420c1cfdddacd2fe1ab98306">&#9670;&nbsp;</a></span>updLast()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">T&amp; <a class="el" href="classOpenSim_1_1Array.html">OpenSim::Array</a>&lt; T &gt;::updLast </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get writable reference to last value in the array. </p>
<dl class="section return"><dt>Returns</dt><dd>writable reference to Last value in the array. </dd></dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname"><a class="el" href="classOpenSim_1_1Exception.html" title="A class for basic exception functionality.">Exception</a></td><td>if the array is empty. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>OpenSim/Common/Array.h</li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceOpenSim.html">OpenSim</a></li><li class="navelem"><a class="el" href="classOpenSim_1_1Array.html">Array</a></li>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:41 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
